//import sql from "../../../inc/sql";
import { clients } from "../../wrapper";

export default new class timer {
  constructor() {
    this.regex = /(\d+)(mon|[smhdwy])/;
    this.calc = {
      y:   365 * 24 * 60 * 60,  // years
      mon: 30 * 24 * 60 * 60,   // months
      w:   7 * 24 * 60 * 60,    // weeks
      d:   24 * 60 * 60,        // days
      h:   60 * 60,             // hours
      m:   60,                  // minutes
      s:   1                    // seconds
    };
    this._timers = new Map();
    setInterval(() => { this.loop(); }, 1000);
    //setTimeout(() => { this.getTimers(); }, 1000);
  }
  add(time, fn, now = ~~(Date.now() / 1000)) {
    return new Promise((resolve, reject) => {
      try {
        if(!this.regex.test(time))
          return reject("ungültig lol");
        let seconds = 0;
        time.match(/\d+(mon|[smhdwy])/g).forEach(t => {
          const [,val,mod] = t.match(/(\d+)(mon|[smhdwy])/);
          seconds += val * this.calc[mod];
        });
        if(seconds < 1)
          return reject("lel ne");
        const until = now + seconds;
        const rest = until - now;

        if(!this._timers.has(until))
          this._timers.set(until, []);
        this._timers.get(until).push(fn);

        resolve({
          now: new Date(now * 1000),
          rest: rest,
          until: new Date((now + rest) * 1000)
        });
      } catch(err) {
        reject(err);
      };
    });
  }
  loop() {
    this._timers.forEach((val, key) => {
      if(key === ~~(Date.now() / 1000)) {
        val.forEach(k => {
          k.target = JSON.parse(k.target);
          clients.forEach(client => {
            if(client.type.toLowerCase() === k.target.type.toLowerCase() && client.client.network.toLowerCase() === k.target.network.toLowerCase()) {
              client.client.sendmsg("normal", k.target.channel, client.client.format(`[b]${k.target.nick}[/b]: ${k.message} [i](${k.delay})[/i]`));
            }
          });
          this._timers.delete(key);
        });
      }
    });
  }
};
